using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Edit;
using Syncfusion.Windows.Forms.Edit.Implementation.Parser;
using Syncfusion.Windows.Forms.Edit.Interfaces;
using Syncfusion.Windows.Forms.Edit.Utils;

namespace EditTest
{
    public partial class Form1 : Form
    {
        private EditControl editor;
        private Button button1;
        private Button button2;
        private Button button3;


        public Form1()
        {
            InitializeComponent();

            this.editor = new EditControl();
            this.editor.Dock = DockStyle.Fill;
            this.Controls.Add(this.editor);


            this.button1 = new Button();
            this.button1.Text = "DeleteAll";
            this.button1.Dock = DockStyle.Bottom;
            this.button1.Click += this.DeleteAll_Click;
            this.Controls.Add(this.button1);


            this.button2 = new Button();
            this.button2.Text = "Mark all ReadOnly";
            this.button2.Dock = DockStyle.Bottom;
            this.button2.Click += this.MakeReadOnly_Click;
            this.Controls.Add(this.button2);


            this.button3 = new Button();
            this.button3.Text = "Set some text";
            this.button3.Dock = DockStyle.Bottom;
            this.button3.Click += this.SetSomeText_Click;
            this.Controls.Add(this.button3);

            this.SetSomeText_Click(this, new System.EventArgs());
        }

        private void DeleteAll_Click(object sender, System.EventArgs e)
        {
            this.editor.DeleteAll();
        }

        private CoordinatePoint GetCurrentCoordinatePoint()
        {
            RenderableLexemParser parser = this.editor.Parser;
            IParsePoint parsePoint = parser.GetParsePoint(this.editor.CurrentPosition.Y, this.editor.CurrentPosition.X);
            return parser.GetCoordinatePoint(parsePoint);
        }

        private void MakeReadOnly_Click(object sender, System.EventArgs e)
        {
            this.editor.MoveToBeginning();
            CoordinatePoint start = this.GetCurrentCoordinatePoint();
            this.editor.MoveToEnd();
            CoordinatePoint end = this.GetCurrentCoordinatePoint();
            this.editor.MarkAsReadOnly(start, end, Color.Red, Color.Green);
        }

        private void SetSomeText_Click(object sender, System.EventArgs e)
        {
            this.editor.Text = "foo\nbar\nbaz\nqux\n\nquux";
        }

    }
}